const kYMSERVICE_CONTRACTID = "@mozilla.org/yahooMailNotiferService;1"
const kYMSERVICE_CID = Components.ID("fbcfac70-1571-11da-8cd6-0800200c9a66");
const nsISupports = Components.interfaces.nsISupports;

function nsYMNotiferService() {}

// our functions (defined in idl file)
//
nsYMNotiferService.prototype.onStateChange = function(aState) {
}

// the interfaces we support (ourself and our parent interface)
//
nsYMNotiferService.prototype.QueryInterface = function(iid) {
  if (!iid.equals(Components.interfaces.nsIYMNotifierService) &&
      !iid.equals(nsISupports))
    throw Components.results.NS_ERROR_NO_INTERFACE;
  return this;
}

/**
 * JS XPCOM component registration:
 *
 */

var nsYMNotiferServiceModule = new Object();

nsYMNotiferServiceModule.registerSelf = function (compMgr, fileSpec, location, type) {
  compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
  compMgr.registerFactoryLocation(kYMSERVICE_CID,
                                  "nsYMNotiferService",
                                  kYMSERVICE_CONTRACTID,
                                  fileSpec, 
                                  location, 
                                  type);
}

nsYMNotiferServiceModule.getClassObject = function (compMgr, cid, iid) {
  if (!cid.equals(kYMSERVICE_CID))
    throw Components.results.NS_ERROR_NO_INTERFACE;

  if (!iid.equals(Components.interfaces.nsIFactory))
    throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

  return nsYMNotiferServiceFactory;
}

nsYMNotiferServiceModule.canUnload = function (compMgr) {
  return true;
}

var nsYMNotiferServiceFactory = new Object();

nsYMNotiferServiceFactory.createInstance = function (outer, iid) {
  if (outer != null)
    throw Components.results.NS_ERROR_NO_AGGREGATION;

  if (!iid.equals(Components.interfaces.nsIYMNotifierService) &&
      !iid.equals(nsISupports))
    throw Components.results.NS_ERROR_NO_INTERFACE;

  return new nsYMNotiferService();
}

function NSGetModule(compMgr, fileSpec) {
  return nsYMNotiferServiceModule;
}
